//
//            ̼(BSC)Ա
//            Baby Fox Simple Class
//
//    ̱ȨʹȨг򰮺
//
//                class FBits
//

#ifndef _FBits_Appeared_
#define _FBits_Appeared_

#include <string.h>
#include <math.h>

class FBits
{
private:
    unsigned char *data;
    unsigned int  size;
    bool bDel;
    void release();

public:
    FBits(char   cData)  {data=NULL; operator =(cData);}
    FBits(short  nData)  {data=NULL; operator =(nData);}
    FBits(int    nData)  {data=NULL; operator =(nData);}
    FBits(long   lData)  {data=NULL; operator =(lData);}
    FBits(float  fData)  {data=NULL; operator =(fData);}
    FBits(double dData)  {data=NULL; operator =(dData);}
    FBits(long double ldData) {data=NULL; operator =(ldData);}
    FBits(char  *szData) {data=NULL; operator =(szData);}
    FBits(FBits &bData)  {data=NULL; operator =(bData);}
    FBits(void *pData=NULL, unsigned int nSize=0){data=NULL; setData(pData, nSize);}
    virtual ~FBits(){release();}

    FBits &operator =(char   cData){setData(&cData, sizeof(char));   return *this;}
    FBits &operator =(short  nData){setData(&nData, sizeof(short));  return *this;}
    FBits &operator =(int    nData){setData(&nData, sizeof(int));    return *this;}
    FBits &operator =(long   lData){setData(&lData, sizeof(long));   return *this;}
    FBits &operator =(float  fData){setData(&fData, sizeof(float));  return *this;}
    FBits &operator =(double dData){setData(&dData, sizeof(double)); return *this;}
    FBits &operator =(long double ldData){setData(&ldData, sizeof(long double)); return *this;}
    FBits &operator =(char  *szData);
    FBits &operator =(FBits &bData);

    FBits &setData(void *pData=NULL, unsigned int nSize=0);
    void *getData(){return data;}

    bool   getBit(unsigned int nIndex);
    FBits &setBit(unsigned int nIndex, bool bBit);
    FBits &Attach(void *pData, unsigned int nSize);
    void   Detach(){data=NULL; size=0;bDel=true;}
    unsigned int getSize(){return size;}
};

void FBits::release()
{
    if(bDel)
        delete[]data;

    bDel=true;
}

FBits &FBits::operator =(char *szData)
{
    release();
    if(szData)
	setData((void *)szData, strlen(szData));
    else
	setData(NULL, 0);

    return *this;
}

FBits &FBits::setData(void *pData, unsigned int nSize)
{
    release();
    if(pData)
    {
	data=new unsigned char[nSize];
	memcpy(data, pData, size=nSize);
    }
    else
    {
	data=NULL;
	size=0;
    }

    return *this;
}

FBits &FBits::operator =(FBits &bData)
{
    release();
    data=new unsigned char[bData.size];
    memcpy(data, bData.data, bData.size);
    return *this;
}

bool FBits::getBit(unsigned int nIndex)
{
    if(nIndex>8*size)
	return false;
    return ((*(data+nIndex/8))&((unsigned char)pow(2, nIndex%8)))!=0;
}

FBits &FBits::setBit(unsigned int nIndex, bool bBit)
{
    if(nIndex>8*size)
	return *this;

    unsigned char *pointer=data+nIndex/8;
    unsigned char filter=(unsigned char)pow(2, nIndex%8);
    (*pointer)&=(~filter);
    (*pointer)|=(filter*bBit);

    return *this;
}

FBits &FBits::Attach(void *pData, unsigned int nSize)
{
    release();
    data=(unsigned char *)pData;
    size=nSize;
    bDel=false;
    return *this;
}
#endif
